
LireCsv=function(chemin,colonnes=NULL, numeriques=NULL, attendus,sep=";",dec=",")
{
	#numeriques est le vecteur des numéros de colonnes (après passage par le filtre du paramètre colonnes) pour lesquelles il faut vérifier le type numérique
	retour=read.table(chemin,header=TRUE,sep=sep,dec=dec)
	
	if (!is.null(colonnes))
		retour=retour[,colonnes]
	
	if (length(names(retour)) != length(attendus))
		stop(paste(length(attendus),"colonnes attendues et",length(names(retour)),"trouvées (vérifiez le séparateur ou précisez le paramètre colonnes).",sep=" "))
	
	if (!is.null(numeriques))
		for (i in numeriques)
			if (class(retour[,i]) != "numeric" && class(retour[,i]) != "integer")
			{
				tryCatch(as.numeric(as.vector(retour[,i])),warning = function(w) {}) #Le tryCatch sert à faire taire le warning lors de la conversion. Le as.vector est là pour le cas où la donnée serait factor.
				stop(paste("Valeures non numériques ( et de classe",class(retour[,i]),") dans",attendus[i],"(colonne",i,":",names(retour)[i],"). \n Ligne",lignes[1],"=",retour[lignes[1],i],sep=" "))			
			}
	
	return(retour)
}
