
setClass(Class = "TableMortalite",contains = "Tableaux",representation=representation(Lx="list",AgeMin="numeric",AgeMax="numeric"))
#Les tables de l'objet Tableaux contiennent les Qx (pour affichage, et pour calcul rapide dans le cas de pas de projection annuel).
#Les Lx sont contenues dans une list supplémentaire "Lx".

#Constructeur à partir d'un fichier:

read.TableMortalite = function(chemin, colAge=1,colLx=2,sep=";", dec=",")
{
	
	Lx=LireCsv(chemin, colonnes=c(colAge,colLx), sep=sep, dec=dec, attendus=c("Age", "Lx"),numeriques=c(1,2))
	
	###Recherche d'erreurs
	
	#Les erreurs éventuelles de type de données sont gérées dans LireCsv().
	#Vérification complémentaire: Les âges successifs:
	
	n=nrow(Lx)
	if (prod(Lx[,1] != Lx[1,1]:Lx[n,1]))
	{stop("Les âges ne sont pas des années successives!")}
	
	###Fin Recherche d'erreurs
	
	#Pour la rapidité, les qx sont précalculés et stockés. Ils serviront pour les fonction qx(age) avec un age entier.
	
	Qx=Lx #Préparation du terrain pour la définition de Qx
	Qx[1:(n-1),2]=1-Lx[2:n,2]/Lx[1:(n-1),2] #Redéfinition de la deuxième colonne
	Qx[n,2] = 1 #On fixe le dernier Qx à 1 (fin de table)
	
	names(Lx)=c("Age","Lx")
	names(Qx)=c("Age","Qx")
	
	return(new("TableMortalite",tables=list(Qx),Lx=list(Lx),AgeMin=as.integer(Lx[1,1]),AgeMax=as.integer(Lx[n,1]),dates="",affLabel=paste("Qx de la table de mortalité couvrant les",Qx[1,1],"-",Qx[n-1,1],"ans:\n\n"),affTitre="",affNumerique="%"))
	
}
