##Fonctions d'affichage d'un objet Tableaux:

NbreColonnes=6 #Paramètre pour l'affichage des objets Tableaux

#Fonction intérmédiaire pour afficher un élément de tableau:
AfficherElement = function(tableau,im,i,style)
{
	if (i<=im)
	{
		if (style == "1")
			return(paste(prettyNum(tableau[i,1],digits=3,width=3), "ans : ", prettyNum(tableau[i,2],digits=5,width=9)))
		if (style == "%")
			return(paste(prettyNum(tableau[i,1],digits=3,width=3), "ans : ", prettyNum(tableau[i,2]*100,digits=4,width=9),"%"))
	}
	else
		return("")
}

setMethod("show","Tableaux",function(object)
		{
		
			NbreDates=length(object@dates)
			
			cat(object@affLabel) #Afficher le label de début de print (rien ne sera affiché si affLabel=="")
			
			for (t in 1:length(object@tables)) #Pour chaque catégorie (chaque Distinction)...
			{
				if (object@affTitre != "") #... afficher le nom de la catégorie si le titre des catégories est différent de ""
					cat(object@affTitre," ",names(object@tables)[t],":\n\n")	
				
				n=nrow(object@tables[[t]]) #Nombre de lignes dans la catégorie
				
				if (length(object@dates)==1) ##Affichage dans le cas d'une seule date:
				{
					lignes=trunc(n/NbreColonnes) #Obtention du nombre de lignes à tracer par divisions [Nombre de lignes dans la catégorie]/[Nbre de colonnes qu'on veut afficher]
					
					if (lignes != n/NbreColonnes) lignes = lignes + 1 #Arrondi à la hausse si la dernière ligne n'est pas entière
					
					for (i in 1:lignes)
					{ 
						#afficher l'élement de la première colonne (sans espace "     " avant) avec la fonction intermédiaire définie plus haut
						cat(AfficherElement(object@tables[[t]],n,i,style=object@affNumerique)) #cette fonction affiche l'élément tant que i < n (n est ici vu comme le nombre d'éléments total à afficher)
						#puis afficher les éléments des autres colonnes, avec un espace "     " avant
						if (NbreColonnes > 1)
							for (j in 2:NbreColonnes)
								cat("     ",AfficherElement(object@tables[[t]],n,(j-1)*lignes+i,style=object@affNumerique))
						cat("\n")			
						
					}
					
					cat("\n")
				} else ##Affichage dans le cas de plusieurs dates:
				{
					
					#Affichage de la ligne des entêtes (les dates):
					cat("         ",object@dates,"\n")
					
					#Affichage des lignes du tableau:
					for (i in 1:n) #dans ce cas, le nombre de lignes à afficher est tout simplement n puisque les différentes colonnes sont les différentes dates
					{
						cat(prettyNum(object@tables[[t]][i,1],digits=3,width=3), "ans : ") #Afficher l'âge
						for (j in 2:(NbreDates+1)) #Afficher les effectifs. (NbreDates + 1 car il y a la colonne des âges)
							cat(prettyNum(object@tables[[t]][i,j],digits=5,width=9), "|") 
						cat("\n")
					}
					cat("\n") #Pour l'espacement entre les catégories
					
				}
			}
		})
