#L'objet Tableaux contient les propriétés d'affichage.
#L'objet TableMortalite en hérite et ajoute les fonctionnalités de table de mortalité.

setClass("Tableaux", representation(tables="list",dates="character",affLabel="character",affTitre="character",affNumerique="character"),prototype(affLabel="",affTitre="Catégorie",affNumerique="1"))

##Constructeur par fichier:

#dates au format texte
#On s'attend à un fichier avec les colonnes Distinction|Age|Montant. Si ces colonnes ne sont pas renseignées dans cet ordre ou s'il faut piocher 3 colonnes dans un tableau plus large, préciser les numéros des colonnes attendues dans les paramètrec colxxxxx. S'il n y a pas plusieurs catégories à distinguer, on peut mettre colDistinction à 0.

read.Tableaux = function(chemin, dates="", colDistinction=1,colAge=2,colMontant=3,sep=";", dec=",",LibellesAttendus=c("Element de distinction","Age", "Montant"))
{
	#Cette fonction est le constructeur d'un objet Tableaux à partir d'un fichier texte
	#Elle est utilisée notamment pour la création des objets pour lesquels il y a potentiellement une colonne colDistinction pour traiter plusieurs tableaux.
	
	if (colDistinction==0) #C'est à dire que l'utilisateur ne souhaite pas avoir plusieurs tableaux
	{
		tableaufichier=LireCsv(chemin, colonnes=c(colAge,colMontant), sep=sep, dec=dec, attendus=LibellesAttendus[c(2,3)],numeriques=c(1,2)) #Il y aura alors 2 colonnes numériques (age et montant)
		tableaufichier=cbind(rep("Global",nrow(tableaufichier)),tableaufichier)
	}else
	{
		tableaufichier=LireCsv(chemin, colonnes=c(colDistinction,colAge,colMontant), sep=sep, dec=dec, attendus=LibellesAttendus,numeriques=c(2,3))
	}
	
	###Recherche d'erreurs
	
	#Les erreurs éventuelles de type de données sont gérées dans LireCsv().
	#Vérification complémentaire: La date:
	
	if (dates!="")
	{
		if (length(dates)>1)
			stop("Vous ne pouvez entrer qu'une date pour un objet Tableaux chargé depuis un fichier")
		
		if (is.na(strptime(dates,'%d/%m/%Y')))
			stop("Date erronée. Le format attendu est jj/mm/aaaa")
	}
	
	###Fin Recherche d'erreurs
	
	###Traitement de la colDistinction:
	
	tableaufichier[,1]=as.vector(tableaufichier[,1]) #Transformer ce qui est probablement un factor en texte
	
	distinctions=sort(unique(tableaufichier[,1]))
	
	if (colDistinction)
		affvecteur("Les cas de distinction considérés sont: ",distinctions) else
		cat("Pas de cas distinctions considéré.")
	
	retour=list()
	
	for (p in 1:length(distinctions)) #On retourne une table par élément de distinction
	{
		tampon=tableaufichier[tableaufichier[,1]==distinctions[p],c(2,3)] #Variable temporaire, réinitisalisée à chaque itération de cette boucle, et contenant la part de tableau à 3 colonnes retour relative à l'élément de distinction n° p.
		
		agemin=min(tampon[,1])
		agemax=max(tampon[,1])
		ages=agemin:agemax
		
		retour[[p]]=as.data.frame(cbind(ages,rep(0,length(ages)))) #data.frame? #A chaque Distinction, un tableau à 2 colonnes est créé: âge et montant
		
		for (i in 1:nrow(tampon)) #Pour chaque ligne lue pour la Distinction n° p ...
			retour[[p]][retour[[p]][,1]==tampon[i,1],2]=retour[[p]][retour[[p]][,1]==tampon[i,1],2]+tampon[i,2] # On ajoute le montant tampon[i,2] à la bonne position dans retour[[p]] ( en l'occurrence retour[[p]][retour[[p]][,1]==tampon[i,1],2] )  
		
		names(retour[[p]]) = c("Age",dates)
	}
	
	names(retour)=distinctions
	
	
	###Fin - Traitement de la colDistinction:
	
	return(new("Tableaux",tables=retour,dates=dates,affLabel=ConstruireEtiquette(distinctions=distinctions,dates=dates,nomobjet="Tableaux")))
	
}
